import {Player, world,system} from "@minecraft/server"
import {ModalFormData,ActionFormData} from '@minecraft/server-ui'

const prefixes = ['!', '=', '-', '+', '=', '÷', '×', '%', '#', '.', '~', '$'];
const forbiddenClans = ['owner','staff','admin', 'null', '0wner', 'own3r', 'niger', 'n-word', 'nword', 'hardr', 'nigger', 'nig', 'n1gg3r', ]

function denyUI(target, nextUI, uiData) {
    target.playSound('error');
    nextUI(target, uiData);
}

function joinClan(viewer,prevError = '') {
    if (!(viewer instanceof Player)) return;

    const ui = new ActionFormData();
    ui.title('THAM GIA BANG HỘI');
    ui.body('DANH SÁCH BANG HỘI');

    const clanButtons = new Set(); // Use a Set to store unique clan names.

    for (const player of world.getAllPlayers()) {
        for (const tag of player.getTags()) {
            const parts = tag.split(':');
            if (parts.length === 2) {
                const key = parts[0].trim();
                const value = parts[1].trim();

                if (key === 'Clan') {
                    clanButtons.add(value); // Add the clan name to the Set.
                }
            }
        }
    }

    if (clanButtons.size === 0) {
        ui.body('KHÔNG CÓ BANG HỘI NÀO ĐƯỢC TẠO.');
    } else {
        clanButtons.forEach((clanName) => {
            ui.button(clanName);
        });
    }
    ui.button('QUAY LẠI')
    ui.show(viewer).then(({ canceled, selection }) => {
        if (canceled) return;
        const selectedClan = [...clanButtons][selection]; // Convert Set to an array and select the clan by index.
        if (selection == clanButtons.length +1){
            search(viewer)
        }
        const existingClanTags = viewer.getTags().filter((tag) => tag.startsWith('Clan:'));
        existingClanTags.forEach((tag) => viewer.removeTag(tag));
        viewer.addTag(`Clan:${selectedClan}`);
        viewer.sendMessage(`Bạn đã tham gia bang hội "${selectedClan}"`);
    });
}

function createClan(viewer,prevError = '') {
    if (!(viewer instanceof Player)) return;

    const ui = new ModalFormData();

    // Ask for a clan name
    ui.title("TẠO BANG HỘI");
    ui.textField(`Clan Name §c${prevError}`, "NHẬP TÊN BANG HỘI");

    ui.show(viewer).then(({ canceled, formValues }) => {
        if (canceled) return;
        const clanName = formValues[0];

        for (const forbiddenName of forbiddenClans) {
            if (clanName.toLowerCase().includes(forbiddenName.toLowerCase())) {
                denyUI(viewer, createClan, 'TÊN BANG HỘI KHÔNG HỢP LỆ');
                return;
            }
        }
        // Check if the clan name contains only allowed characters (alphabet and §).
        const isNameValid = /^[A-Za-z0-9§]+$/.test(clanName);;

        if (!isNameValid) {
            denyUI(viewer,createClan, "KÝ TỰ KHÔNG HỢP LỆ");
            return;
        }

        // Check if the clan name is already taken (assuming players have tags in the format "Clan:clanname").
        const existingClanTag = `Clan:${clanName}`;
        if (viewer.getTags().includes(existingClanTag)) {
            denyUI(viewer,createClan, "TÊN BỊ TRÙNG VỚI BANG HỘI KHÁC");
            return;
        }

        // Check if the clan name is too long (greater than 12 characters).
        if (clanName.length > 12) {
            denyUI(viewer,createClan, "TÊN QUÁ DÀI");
            return;
        }

        // Remove all existing clan tags and give the selected one
        const existingClanTags = viewer.getTags().filter((tag) => tag.startsWith('Clan:'));
        existingClanTags.forEach((tag) => viewer.removeTag(tag));
        viewer.addTag(existingClanTag);

        viewer.sendMessage(`Bạn đã thành công tạo bang hội "${clanName}"`);
    });
}


// Main menu
function search(viewer,prevError = '') {
    const ui = new ActionFormData();
    ui.title("MENU BANG HỘI");

    ui.button('TẠO');
    ui.button('THAM GIA');

    ui.show(viewer).then(({canceled,selection})=>{
        if (canceled)return
        if (selection === 0){
            createClan(viewer)
        }
        if (selection ===1){
            joinClan(viewer)
        }
    });
}

world.beforeEvents.chatSend.subscribe((data) => {
    const player = data.sender;
    const message = data.message;
    const command = data.message.split(' ')
    const tags = player.getTags();
    switch (command[0]){
        case "%clans":
            data.cancel = true
            player.sendMessage("§eĐÓNG CHAT ĐỂ HIỆN MENU")
            system.runTimeout(()=>{search(player)},80)
            return
        default:break
    }



    for (const prefix of prefixes) {
        if (message.startsWith(prefix)) {
            return;
        }
    }

    let clan = null;
    let rank = null;

    for (const tag of tags) {
        const parts = tag.split(':');
        if (parts.length === 2) {
            const key = parts[0].trim();
            const value = parts[1].trim();

            if (key === 'Clan') {
                clan = value;
            } else if (key === 'Rank') {
                rank = value;
            }
        }
    }
    if (clan != null && rank != null){
        data.cancel = true
        world.sendMessage(`§g[§r${rank}§r§g]§r §8[§r${clan}§r§8]§r <${player.name}§r> ${message}`)
        return
    }
    if (clan != null){
        data.cancel = true
        world.sendMessage(`§g[§r§bThành viên§r§g]§r §8[§r${clan}§r§8]§r <${player.name}§r> ${message}`)
        return
    }
    if (rank != null){
        data.cancel = true
        world.sendMessage(`§g[§r${rank}§r§g]§r <${player.name}§r> ${message}`)
        return
    }
});